////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// (c) AgileBio 2011
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
getCutter = function(enzymeClassName, secondaryForm) {
	var sess_id = document.getElementById('sess_id').value;
	var query   = document.getElementById('query_cutter').value;
	var choice;
	if      (document.getElementById('choice_ALL').checked)    { choice = 'all';  }
	else if (document.getElementById('choice_NO_ALL').checked) { choice = 'size'; }
	else if (document.getElementById('choice_SPEC').checked)   { choice = 'spec'; }
	
	if (secondaryForm) { choice = 'spec'; }

	var number  = document.getElementById('number').value;
	var listEnz = getSelectedEnzymes(enzymeClassName);
	
	document.getElementById('tabbar_display').style.display = '';
	
	var tmpDivId       = "id_" + (idDivTabbar++);
	var inHtmlNewDivId = "div_" + tmpDivId;
	tabbar.addTab(tmpDivId, "Cut number: "+idDivTabbar, "120px");
	tabbar.setContentHTML(tmpDivId, '<div align="center" style="position: relative; width: 100%; height: 100%; margin-top: 50px;"><img src="bio_php2/cutter/imgs/ajax-loader.gif" height="32" width="32" style="margin: auto auto;"></div>');
	tabbar.setTabActive(tmpDivId);
	
	document.location.href = '#tabbar_display';
	
	jQuery.ajax({ 
		type: "POST", 
		url: "bio_php2/cutter/ajax/cutterresults.php", 
		async: true, 
		data: "sess_id="+sess_id+"&query="+query+"&choice="+choice+"&number="+number+listEnz, 
		dataType: "html",
		success: function(data){ 
			document.getElementById("cutterResults").innerHTML += '<div id="'+inHtmlNewDivId+'" style="position: relative; width: 100%; height: 100%; overflow: auto; display: block;">'+data+'</div>';
			document.getElementById(inHtmlNewDivId).style.display = 'none';
			tabbar.setContent(tmpDivId, inHtmlNewDivId);
			tabbar.normalize();
			tabbar.enableAutoReSize(true);
			//$("#cutterResults").html(data);
		} // success
	}); // ajax
} // function getCutter()
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
clearCutter = function () {
	if (!confirm("You will clear the sequence, do you want to continue?")) { return; }
	// reset the form
	document.getElementById('query_cutter').value           = '';
	document.getElementById('choice_NO_ALL').checked = true;
	document.getElementById('number').value          = '6';
	document.getElementById('divAllEnz').innerHTML   = '';
	// reset the resutls
	tabbar.clearAll();
	dhxWins.forEachWindow(function(win) { win.close(); });
	idDivTabbar = 0;
	idPrefix    = 1;
} // function clearCleaner()
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
getSelectedEnzymes = function (enzymeClassName) {
	var ret     = '';
	var listEnz = document.getElementsByClassName(enzymeClassName); 
	for (var i in listEnz) {
		try { 
			var myElem = document.getElementById(listEnz[i].id);
			if ((myElem.type == 'hidden') || ((myElem.type == 'checkbox') && (myElem.checked))  ) { 
				ret += '&enz_'+i+'='+myElem.value;
			}
		} catch (e) {}
	} // for (var i in listEnz)
	return ret;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function addDivEnz(idEnz, color) {
	if (idEnz =='') { return;}
	try {
		var testAd = document.getElementById(idEnz).value;
		alert('Enzyme already added!');
	}
	catch (e) {
		var myDiv = '<div id="'+idEnz+'" class="enzdiv-inline-block filter-chip" style="display: inline; background-color:'+color+'" tabindex="0">';
		myDiv    += '<span class="enzdiv-inline-block">&nbsp;'+idEnz+'&nbsp;|</span>';
		myDiv    += '<input type="hidden" class="selectedEnzymes_1" id="selected_enz_'+idEnz+'" value="'+idEnz+'" />';
		myDiv    += '<input type="hidden" id="'+idEnz+'_color" value="'+color+'" />';
		myDiv    += '<span class="enzdiv-inline-block" onclick="delDivEnz(\''+idEnz+'\');" title="Delet Enzyme '+idEnz+' from Selection" alt="Delet Enzyme '+idEnz+' from Selection">x</span>';
		myDiv    += '</div>&nbsp;&nbsp;';
		document.getElementById('divAllEnz').innerHTML += myDiv;
	}
} // function addDivEnz(idEnz)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function delDivEnz(idEnz) {
	var myDiv = '';
	var splitter = document.getElementById('divAllEnz').childNodes;
	for (var i = 0; i < splitter.length; i++) {
		if (splitter[i].id != idEnz ) { 
			var idColor = splitter[i].id+'_color';
			try {
				myDiv += '<div id="'+splitter[i].id+'" class="enzdiv-inline-block filter-chip" style="display: inline; background-color:'+document.getElementById(idColor).value+';" tabindex="0">';
				myDiv += splitter[i].innerHTML;
				myDiv += '</div>&nbsp;&nbsp;';
			} catch (e) {}
		}
	} // for (var i = 0; i < splitter.length; i++) 
	document.getElementById('divAllEnz').innerHTML = myDiv;
} //function delDivEnz(idEnz)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function topElement(e) {
	return ((e && topElement != topElement.caller)?e.offsetTop:0) + ((e && e.offsetParent)?e.offsetParent.offsetTop + topElement(e.offsetParent):0);
} // function topElement(e) {
function leftElement(e) {
	return ((e && leftElement != leftElement.caller)?e.offsetLeft:0) + ((e && e.offsetParent)?e.offsetParent.offsetLeft + leftElement(e.offsetParent):0);
} // function leftElement(e) 
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function switchClass(element, idDiv, className1, className2, display_seq_zone) {
	var div = document.getElementById(idDiv);
	var browserFactorY, browserFactorX ;
	if      ( navigator.userAgent.match(/Firefox/i) )       { browserFactorY = 114;  browserFactorX = -15; }
	else if ( navigator.userAgent.match(/Safari/i) )        { browserFactorY = 116;  browserFactorX = -13; }
	else if ( navigator.userAgent.match(/Chrome/i) )        { browserFactorY = 147;  browserFactorX = -14; }
	else if ( navigator.userAgent.match(/Opera/i) )         { browserFactorY = 110;  browserFactorX = -14; }
	else if ( navigator.userAgent.match(/MSIE/i) )          { browserFactorY = 124;  browserFactorX = -14; }
	else                                                    { browserFactorY = 124;  browserFactorX = -14; }
	if (div.className == className1) {
		div.className = className2;
		document.getElementById(idDiv).style.left = ( Number(leftElement(element)) - Number(leftElement(document.getElementById(display_seq_zone))) + browserFactorX ) + 'px';
		// - Number(leftElement( document.getElementById('tabbar_display') ))  + Number(leftElement( document.getElementById('pagewrapper') )) ; 
		document.getElementById(idDiv).style.top  = ( Number(topElement(element)) - Number(div.offsetHeight) - Number(topElement(document.getElementById(display_seq_zone))) + browserFactorY ) + 'px';
		// - Number(topElement( document.getElementById('tabbar_display') )) - 26 )+ 'px' ;//; // or 25
	} else if (div.className == className2) {
		div.className = className1; 
		document.getElementById(idDiv).style.left = ( Number(leftElement(element)) - Number(leftElement(document.getElementById(display_seq_zone))) + browserFactorX ) + 'px' ;
		// - Number(leftElement( document.getElementById('tabbar_display') )) )+ 'px' ;//+ Number(leftElement( document.getElementById('pagewrapper') )) ; 
		document.getElementById(idDiv).style.top  = ( Number(topElement(element)) - Number(div.offsetHeight) - Number(topElement(document.getElementById(display_seq_zone))) + browserFactorY ) + 'px';
		// - Number(topElement( document.getElementById('tabbar_display') )) - 26 )+ 'px' ;//; // or 25
	}
} // function switchClass(element, idDiv, className1, className2)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function getEnzymePostion(data) {
	var drop = data.split(': ');
	var tab  = drop[1].split(', ');
	return tab;
} // function getEnzymePostion(data)
function byNumVal(a1,a2) {
	a1 = Number(a1); a2= Number(a2);
	if (a1 < a2)  { return -1; }
	if (a1 > a2)  { return 1;  }
	if (a1 == a2) { return 0;  }
} // function byNumVal(a1,a2)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function addToArray(a1, a2) {
	for( var k in a2 ) { alert(a2[k]); }
	var r = a1;
	for( var k in a2 ) {
		if(r.hasOwnProperty(k)) { continue; }
		else                    { r[k] = a2[k]; }
	}
	return r;
} //addToArray(a1, a2)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function createWindow(title, element, enzName, listPos, className1, className2, idReq) {
    var id = "userWin_" + (idPrefix++);
	var w = 600;
	var h = 500;
	var x = 50;
	var y = Number(topElement(element)) - Number(topElement( document.getElementById('tabbar_display') )) - 100;
    dhxWins.createWindow(id, x, y, w, h);
    dhxWins.window(id).setText(title);
	var req = 'query='+document.getElementById('query_cutter').value;
	if (className1) {
		var tabCutEnz = [];
		var tabCutPos = [];
		var allCheckBox = document.getElementsByClassName(className1);
		for (var i = 0; i < allCheckBox.length; i++) {
			if (allCheckBox[i].checked) {
				if(!tabCutEnz.hasOwnProperty(allCheckBox[i].value)) { tabCutEnz = tabCutEnz.concat(allCheckBox[i].value); }
				var t_pos = getEnzymePostion( document.getElementById( 'hiddenData_'+idReq+'_'+allCheckBox[i].value ).value );
				for (var j in t_pos ) { if(!tabCutPos.hasOwnProperty(t_pos[j])) { tabCutPos = tabCutPos.concat(t_pos[j]); } }
			} //fi (allCheckBox[i].checked) {
		} // for (var i = 0; i < allSeqSeq.length; i++)
		for( var k in tabCutEnz ) { req += '&enz_'+k+'='+tabCutEnz[k]; }
		tabCutPos = tabCutPos.sort(byNumVal);
		for( var k in tabCutPos ) { req += '&pos_'+k+'='+tabCutPos[k]; }
	} else {
		req += '&enz_1='+enzName;
		var tabCupttPos = getEnzymePostion(listPos);
		for (var a in tabCupttPos) {
			req += '&pos_'+a+'='+tabCupttPos[a];
		}
	}
	jQuery.ajax({ 
		type: "POST",
		url: "bio_php2/cutter/ajax/cutterresultscutpos.php", 
		async: true, 	
		data: req, 
		dataType: "html",
		success: function(data){ 
			dhxWins.window(id).attachHTMLString('<div id="obj_'+idPrefix+'" style="height: 100%; overflow: auto; background-color:#FFFFFF;">'+data+'</div>');
		} // success
	});
} // function createWindow(title, element, enzName, listPos, className1, className2, idReq)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
var gAutoPrint = true; // Flag for whether or not to automatically call the print function
printSpecialCutter = function(idDiv){
	if (document.getElementById != null) {
		var html = '<HTML>\n<HEAD>\n';
//		html    += '<link rel="stylesheet" href="bio_php2/cutter/css/stylepreprint.css" type="text/css"/>';
//		html    += '<link rel="stylesheet" href="bio_php2/cutter/css/styleprint.css" media="print" type="text/css"/>';
		html    += '<link rel="stylesheet" type="text/css" href="bio_php2/cutter/css/style_cutter_print.css" />';
		html    += '<script>switchClass = function() { return null; }</script>';
		html    += '\n</HE' + 'AD>\n<BODY leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">\n';
		var printReadyElem = document.getElementById(idDiv);
		if (printReadyElem != null){
			html += printReadyElem.innerHTML;
		} else {
			alert("Could not find the printReady section in the HTML");
			return;
		}	
		html += '\n</BO' + 'DY>\n</HT' + 'ML>';
		var printWin = window.open("","printSpecial");
		printWin.document.open();
		printWin.document.write(html);
		printWin.document.close();
		if (gAutoPrint) {
			printWin.print();
		}
	} else {
		alert("Sorry, the print ready feature is only available in modern browsers.");
	}
} // printSpecialCutter = function()
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function cutAtSelectPos(title, element, className) {
    var id = "userWin_" + (idPrefix++);
	var w = 600;
	var h = 500;
	var x = 50;
	var y = Number(topElement(element)) - Number(topElement( document.getElementById('tabbar_display') )) - 100;
    dhxWins.createWindow(id, x, y, w, h);
    dhxWins.window(id).setText(title);
	var req = 'query='+document.getElementById('query_cutter').value;
	var allCheckBox = document.getElementsByClassName(className);
	for (var i = 0; i < allCheckBox.length; i++) {
		if (allCheckBox[i].checked) {
			req += '&pos_'+i+'='+allCheckBox[i].value;
		} //fi (allCheckBox[i].checked) {
	} // for (var i = 0; i < allSeqSeq.length; i++)
	jQuery.ajax({ 
		type: "POST",
		url: "bio_php2/cutter/ajax/cutterresultscutpos.php", 
		async: true, 	
		data: req, 
		dataType: "html",
		success: function(data){ 
			dhxWins.window(id).attachHTMLString('<div id="obj_'+idPrefix+'" style="height: 100%; overflow: auto; background-color:#FFFFFF;">'+data+'</div>');
		} // success
	});
} //function cutAtSelectPos(class)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function showHideSequence(idDiv, idImg, but1, but2){
	if (document.getElementById(idDiv).style.display == 'none') { 
		document.getElementById(idDiv).style.display = 'block';
		document.getElementById(but1).style.display  = 'block';
		document.getElementById(but2).style.display  = 'block';
		document.getElementById(idImg).src           = 'images/16/413-up2.gif';
	} else {
		document.getElementById(idDiv).style.display = 'none'; 
		document.getElementById(but1).style.display  = 'none';
		document.getElementById(but2).style.display  = 'none';
		document.getElementById(idImg).src           = 'images/16/411-down2.gif';
		
	} // fi else if (document.getElementById(idDiv).style.display == 'none')
} // function showHideSequence(idDiv, idImg)
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////